﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Input;
using Infragistics.Windows.DockManager;

namespace XamDockManagerLayout
{
    public class MainWindowViewModel : BaseViewModel
    {
        private BaseViewModel _currentViewModel;
        public BaseViewModel CurrentViewModel
        {
            get { return _currentViewModel; }
            set
            {
                if (_currentViewModel != value)
                {
                    _currentViewModel = value;
                    OnPropertyChanged("CurrentViewModel");
                }
            }
        }

        private DockManagerViewModel _dockManagerViewModel = new DockManagerViewModel();
        private OtherViewModel _otherViewModel = new OtherViewModel();

        public MainWindowViewModel()
        {
            CurrentViewModel = _dockManagerViewModel;
        }

        public void SetDockManager()
        {
            CurrentViewModel = _dockManagerViewModel;
        }
        public void SetOther()
        {
            CurrentViewModel = _otherViewModel;
        }
    }

    public class DockManagerViewModel : BaseViewModel
    {
        private string _dockManagerLayout;
        public string DockManagerLayout
        {
            get { return _dockManagerLayout; }
            set
            {
                if (_dockManagerLayout != value)
                {
                    _dockManagerLayout = value;
                    OnPropertyChanged("DockManagerLayout");
                }
            }
        }

        private DelegateCommand<MouseButtonEventArgs> _OnHendayPaneFocusCommand;
        public DelegateCommand<MouseButtonEventArgs> OnHendayPaneFocusCommand
        {
            get { return _OnHendayPaneFocusCommand; }
            set
            {
                if (_OnHendayPaneFocusCommand != value)
                {
                    _OnHendayPaneFocusCommand = value;
                    OnPropertyChanged("OnHendayPaneFocusCommand");
                }
            }
        }

        public DockManagerViewModel()
        {
            OnHendayPaneFocusCommand = new DelegateCommand<MouseButtonEventArgs>(new Action<MouseButtonEventArgs>(OnExecuted));
        }

        void OnExecuted(MouseButtonEventArgs e)
        {
            MessageBox.Show("Command executed");
        }
    }

    public class OtherViewModel : BaseViewModel
    {

    }
}
